<?php

declare(strict_types=1);
/**
 *  Saferpay PaymentService
 *  NOTICE OF LICENSE
 *
 * Once you have purchased the software with PIT Solutions AG
 * or one of its  authorised resellers and provided that you comply with the conditions of this contract,
 * PIT Solutions AG grants you a non-exclusive license,
 * unlimited in time for the usage of the software in the manner of and for the purposes specified in License.txt
 * available in extension package, according to the subsequent regulations
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to
 * newer versions in the future.
 */

namespace Saferpay\Shopware\Core\Content\Saferpay;

use DateTimeInterface;
use Shopware\Core\Framework\DataAbstractionLayer\Entity;
use Shopware\Core\Framework\DataAbstractionLayer\EntityIdTrait;

class SaferpayCustomerSecureTransactionEntity extends Entity
{
    use EntityIdTrait;

    protected ?string $saferpayRequestId;
    protected ?string $saferpayToken;
    protected ?string $saferpayAliasId;
    protected ?int $saferpayAliasLifetime;
    protected ?string $saferpayPaymentMethod;
    protected ?string $saferpayDisplayText;
    protected ?string $saferpayMaskedNumber;
    protected ?string $saferpayExpYear;
    protected ?string $saferpayExpMonth;
    protected ?string $saferpayHolderName;
    protected ?string $customerId;
    protected ?int $saferpayCustomerId;
    protected ?string $saferpayAuthenticated;
    protected ?string $liveTransaction;
    protected ?string $aliasActive;
    protected ?DateTimeInterface $saferpayCreatedAt;


    /**
     * Get the value of saferpayRequestId
     */
    public function getSaferpayRequestId()
    {
        return $this->saferpayRequestId;
    }

    /**
     * Set the value of saferpayRequestId
     *
     * @return  self
     */
    public function setSaferpayRequestId($saferpayRequestId)
    {
        $this->saferpayRequestId = $saferpayRequestId;

        return $this;
    }

    /**
     * Get the value of saferpayToken
     */
    public function getSaferpayToken()
    {
        return $this->saferpayToken;
    }

    /**
     * Set the value of saferpayToken
     *
     * @return  self
     */
    public function setSaferpayToken($saferpayToken)
    {
        $this->saferpayToken = $saferpayToken;

        return $this;
    }

    /**
     * Get the value of saferpayAliasId
     */
    public function getSaferpayAliasId()
    {
        return $this->saferpayAliasId;
    }

    /**
     * Set the value of saferpayAliasId
     *
     * @return  self
     */
    public function setSaferpayAliasId($saferpayAliasId)
    {
        $this->saferpayAliasId = $saferpayAliasId;

        return $this;
    }

    /**
     * Get the value of saferpayAliasLifetime
     */
    public function getSaferpayAliasLifetime()
    {
        return $this->saferpayAliasLifetime;
    }

    /**
     * Set the value of saferpayAliasLifetime
     *
     * @return  self
     */
    public function setSaferpayAliasLifetime($saferpayAliasLifetime)
    {
        $this->saferpayAliasLifetime = $saferpayAliasLifetime;

        return $this;
    }

    /**
     * Get the value of saferpayPaymentMethod
     */
    public function getSaferpayPaymentMethod()
    {
        return $this->saferpayPaymentMethod;
    }

    /**
     * Set the value of saferpayPaymentMethod
     *
     * @return  self
     */
    public function setSaferpayPaymentMethod($saferpayPaymentMethod)
    {
        $this->saferpayPaymentMethod = $saferpayPaymentMethod;

        return $this;
    }

    /**
     * Get the value of saferpayDisplayText
     */
    public function getSaferpayDisplayText()
    {
        return $this->saferpayDisplayText;
    }

    /**
     * Set the value of saferpayDisplayText
     *
     * @return  self
     */
    public function setSaferpayDisplayText($saferpayDisplayText)
    {
        $this->saferpayDisplayText = $saferpayDisplayText;

        return $this;
    }

    /**
     * Get the value of saferpayMaskedNumber
     */
    public function getSaferpayMaskedNumber()
    {
        return $this->saferpayMaskedNumber;
    }

    /**
     * Set the value of saferpayMaskedNumber
     *
     * @return  self
     */
    public function setSaferpayMaskedNumber($saferpayMaskedNumber)
    {
        $this->saferpayMaskedNumber = $saferpayMaskedNumber;

        return $this;
    }

    /**
     * Get the value of saferpayExpYear
     */
    public function getSaferpayExpYear()
    {
        return $this->saferpayExpYear;
    }

    /**
     * Set the value of saferpayExpYear
     *
     * @return  self
     */
    public function setSaferpayExpYear($saferpayExpYear)
    {
        $this->saferpayExpYear = $saferpayExpYear;

        return $this;
    }

    /**
     * Get the value of saferpayExpMonth
     */
    public function getSaferpayExpMonth()
    {
        return $this->saferpayExpMonth;
    }

    /**
     * Set the value of saferpayExpMonth
     *
     * @return  self
     */
    public function setSaferpayExpMonth($saferpayExpMonth)
    {
        $this->saferpayExpMonth = $saferpayExpMonth;

        return $this;
    }

    /**
     * Get the value of saferpayHolderName
     */
    public function getSaferpayHolderName()
    {
        return $this->saferpayHolderName;
    }

    /**
     * Set the value of saferpayHolderName
     *
     * @return  self
     */
    public function setSaferpayHolderName($saferpayHolderName)
    {
        $this->saferpayHolderName = $saferpayHolderName;

        return $this;
    }

    /**
     * Get the value of customerId
     */
    public function getCustomerId()
    {
        return $this->customerId;
    }

    /**
     * Set the value of customerId
     *
     * @return  self
     */
    public function setCustomerId($customerId)
    {
        $this->customerId = $customerId;

        return $this;
    }

    /**
     * Get the value of saferpayCustomerId
     */
    public function getSaferpayCustomerId()
    {
        return $this->saferpayCustomerId;
    }

    /**
     * Set the value of saferpayCustomerId
     *
     * @return  self
     */
    public function setSaferpayCustomerId($saferpayCustomerId)
    {
        $this->saferpayCustomerId = $saferpayCustomerId;

        return $this;
    }

    /**
     * Get the value of saferpayAuthenticated
     */
    public function getSaferpayAuthenticated()
    {
        return $this->saferpayAuthenticated;
    }

    /**
     * Set the value of saferpayAuthenticated
     *
     * @return  self
     */
    public function setSaferpayAuthenticated($saferpayAuthenticated)
    {
        $this->saferpayAuthenticated = $saferpayAuthenticated;

        return $this;
    }

    /**
     * Get the value of liveTransaction
     */
    public function getLiveTransaction()
    {
        return $this->liveTransaction;
    }

    /**
     * Set the value of liveTransaction
     *
     * @return  self
     */
    public function setLiveTransaction($liveTransaction)
    {
        $this->liveTransaction = $liveTransaction;

        return $this;
    }

    /**
     * Get the value of aliasActive
     */
    public function getAliasActive()
    {
        return $this->aliasActive;
    }

    /**
     * Set the value of aliasActive
     *
     * @return  self
     */
    public function setAliasActive($aliasActive)
    {
        $this->aliasActive = $aliasActive;

        return $this;
    }

    /**
     * Get the value of saferpayCreatedAt
     */
    public function getSaferpayCreatedAt()
    {
        return $this->saferpayCreatedAt;
    }

    /**
     * Set the value of saferpayCreatedAt
     *
     * @return  self
     */
    public function setSaferpayCreatedAt($saferpayCreatedAt)
    {
        $this->saferpayCreatedAt = $saferpayCreatedAt;

        return $this;
    }
}
