<?php

declare(strict_types=1);
/**
 *  Saferpay PaymentService
 *  NOTICE OF LICENSE
 *
 * Once you have purchased the software with PIT Solutions AG
 * or one of its  authorised resellers and provided that you comply with the conditions of this contract,
 * PIT Solutions AG grants you a non-exclusive license,
 * unlimited in time for the usage of the software in the manner of and for the purposes specified in License.txt
 * available in extension package, according to the subsequent regulations
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to
 * newer versions in the future.
 */

namespace Saferpay\Shopware\Core\Content\Saferpay;

use DateTimeInterface;
use Shopware\Core\Framework\DataAbstractionLayer\Entity;
use Shopware\Core\Framework\DataAbstractionLayer\EntityIdTrait;

class SaferpayPaymentTransactionEntity extends Entity
{
    use EntityIdTrait;

    protected ?string $saferpayRequestId;
    protected ?string $saferpayToken;
    protected ?DateTimeInterface $saferpayTokenExpiryDate;
    protected ?string $orderId;
    protected ?string $orderTransactionId;
    protected ?string $customerId;
    protected ?string $paymentId;
    protected ?string $authorizationMethod;
    protected ?int $saferpayCustomerId;
    protected ?string $transactionType;
    protected ?float $authorizationAmount;
    protected bool $transactionMode;
    protected ?string $currencyCode;
    protected ?string $languageCode;
    protected ?float $capturedAmount;
    protected ?string $captureId;
    protected $saferpayPaymentInfo;
    protected bool $liabilityShiftStatus;
    protected ?string $liableEntity;
    protected bool $threeDsLiabilityShift;
    protected bool $dccStatus;
    protected $dccInfo;
    protected bool $aliasRegisterStatus;
    protected bool $paidStatus;
    protected bool $transactionStatus;
    protected bool $active;
    protected bool $preauth;
    protected bool $recurring;
    protected string $saferpayAliasId;
    protected string $fraudReviewStatus;

    /**
     * Get the value of saferpayRequestId
     */
    public function getSaferpayRequestId()
    {
        return $this->saferpayRequestId;
    }

    /**
     * Set the value of saferpayRequestId
     *
     * @return  self
     */
    public function setSaferpayRequestId($saferpayRequestId)
    {
        $this->saferpayRequestId = $saferpayRequestId;

        return $this;
    }

    /**
     * Get the value of saferpayToken
     */
    public function getSaferpayToken()
    {
        return $this->saferpayToken;
    }

    /**
     * Set the value of saferpayToken
     *
     * @return  self
     */
    public function setSaferpayToken($saferpayToken)
    {
        $this->saferpayToken = $saferpayToken;

        return $this;
    }

    /**
     * Get the value of saferpayTokenExpiryDate
     */
    public function getSaferpayTokenExpiryDate()
    {
        return $this->saferpayTokenExpiryDate;
    }

    /**
     * Set the value of saferpayTokenExpiryDate
     *
     * @return  self
     */
    public function setSaferpayTokenExpiryDate($saferpayTokenExpiryDate)
    {
        $this->saferpayTokenExpiryDate = $saferpayTokenExpiryDate;

        return $this;
    }

    /**
     * Get the value of customerId
     */
    public function getCustomerId()
    {
        return $this->customerId;
    }

    /**
     * Set the value of customerId
     *
     * @return  self
     */
    public function setCustomerId($customerId)
    {
        $this->customerId = $customerId;

        return $this;
    }

    /**
     * Get the value of authorizationMethod
     */
    public function getAuthorizationMethod()
    {
        return $this->authorizationMethod;
    }

    /**
     * Set the value of authorizationMethod
     *
     * @return  self
     */
    public function setAuthorizationMethod($authorizationMethod)
    {
        $this->authorizationMethod = $authorizationMethod;

        return $this;
    }

    /**
     * Get the value of saferpayCustomerId
     */
    public function getSaferpayCustomerId()
    {
        return $this->saferpayCustomerId;
    }

    /**
     * Set the value of saferpayCustomerId
     *
     * @return  self
     */
    public function setSaferpayCustomerId($saferpayCustomerId)
    {
        $this->saferpayCustomerId = $saferpayCustomerId;

        return $this;
    }

    /**
     * Get the value of transactionType
     */
    public function getTransactionType()
    {
        return $this->transactionType;
    }

    /**
     * Set the value of transactionType
     *
     * @return  self
     */
    public function setTransactionType($transactionType)
    {
        $this->transactionType = $transactionType;

        return $this;
    }

    /**
     * Get the value of authorizationAmount
     */
    public function getAuthorizationAmount()
    {
        return $this->authorizationAmount;
    }

    /**
     * Set the value of authorizationAmount
     *
     * @return  self
     */
    public function setAuthorizationAmount($authorizationAmount)
    {
        $this->authorizationAmount = $authorizationAmount;

        return $this;
    }

    /**
     * Get the value of transactionMode
     */
    public function getTransactionMode()
    {
        return $this->transactionMode;
    }

    /**
     * Set the value of transactionMode
     *
     * @return  self
     */
    public function setTransactionMode($transactionMode)
    {
        $this->transactionMode = $transactionMode;

        return $this;
    }

    /**
     * Get the value of currencyCode
     */
    public function getCurrencyCode()
    {
        return $this->currencyCode;
    }

    /**
     * Set the value of currencyCode
     *
     * @return  self
     */
    public function setCurrencyCode($currencyCode)
    {
        $this->currencyCode = $currencyCode;

        return $this;
    }

    /**
     * Get the value of languageCode
     */
    public function getLanguageCode()
    {
        return $this->languageCode;
    }

    /**
     * Set the value of languageCode
     *
     * @return  self
     */
    public function setLanguageCode($languageCode)
    {
        $this->languageCode = $languageCode;

        return $this;
    }

    /**
     * Get the value of capturedAmount
     */
    public function getCapturedAmount()
    {
        return $this->capturedAmount;
    }

    /**
     * Set the value of capturedAmount
     *
     * @return  self
     */
    public function setCapturedAmount($capturedAmount)
    {
        $this->capturedAmount = $capturedAmount;

        return $this;
    }

    /**
     * Get the value of captureId
     */
    public function getCaptureId()
    {
        return $this->captureId;
    }

    /**
     * Set the value of captureId
     *
     * @return  self
     */
    public function setCaptureId($captureId)
    {
        $this->captureId = $captureId;

        return $this;
    }

    /**
     * Get the value of saferpayPaymentInfo
     */
    public function getSaferpayPaymentInfo()
    {
        return $this->saferpayPaymentInfo;
    }

    /**
     * Set the value of saferpayPaymentInfo
     *
     * @return  self
     */
    public function setSaferpayPaymentInfo($saferpayPaymentInfo)
    {
        $this->saferpayPaymentInfo = $saferpayPaymentInfo;

        return $this;
    }

    /**
     * Get the value of liabilityShiftStatus
     */
    public function getLiabilityShiftStatus()
    {
        return $this->liabilityShiftStatus;
    }

    /**
     * Set the value of liabilityShiftStatus
     *
     * @return  self
     */
    public function setLiabilityShiftStatus($liabilityShiftStatus)
    {
        $this->liabilityShiftStatus = $liabilityShiftStatus;

        return $this;
    }

    /**
     * Get the value of liableEntity
     */
    public function getLiableEntity()
    {
        return $this->liableEntity;
    }

    /**
     * Set the value of liableEntity
     *
     * @return  self
     */
    public function setLiableEntity($liableEntity)
    {
        $this->liableEntity = $liableEntity;

        return $this;
    }

    /**
     * Get the value of threeDsLiabilityShift
     */
    public function getThreeDsLiabilityShift()
    {
        return $this->threeDsLiabilityShift;
    }

    /**
     * Set the value of threeDsLiabilityShift
     *
     * @return  self
     */
    public function setThreeDsLiabilityShift($threeDsLiabilityShift)
    {
        $this->threeDsLiabilityShift = $threeDsLiabilityShift;

        return $this;
    }

    /**
     * Get the value of dccStatus
     */
    public function getDccStatus()
    {
        return $this->dccStatus;
    }

    /**
     * Set the value of dccStatus
     *
     * @return  self
     */
    public function setDccStatus($dccStatus)
    {
        $this->dccStatus = $dccStatus;

        return $this;
    }

    /**
     * Get the value of dccInfo
     */
    public function getDccInfo()
    {
        return $this->dccInfo;
    }

    /**
     * Set the value of dccInfo
     *
     * @return  self
     */
    public function setDccInfo($dccInfo)
    {
        $this->dccInfo = $dccInfo;

        return $this;
    }

    /**
     * Get the value of aliasRegisterStatus
     */
    public function getAliasRegisterStatus()
    {
        return $this->aliasRegisterStatus;
    }

    /**
     * Set the value of aliasRegisterStatus
     *
     * @return  self
     */
    public function setAliasRegisterStatus($aliasRegisterStatus)
    {
        $this->aliasRegisterStatus = $aliasRegisterStatus;

        return $this;
    }

    /**
     * Get the value of paidStatus
     */
    public function getPaidStatus()
    {
        return $this->paidStatus;
    }

    /**
     * Set the value of paidStatus
     *
     * @return  self
     */
    public function setPaidStatus($paidStatus)
    {
        $this->paidStatus = $paidStatus;

        return $this;
    }

    /**
     * Get the value of transactionStatus
     */
    public function getTransactionStatus()
    {
        return $this->transactionStatus;
    }

    /**
     * Set the value of transactionStatus
     *
     * @return  self
     */
    public function setTransactionStatus($transactionStatus)
    {
        $this->transactionStatus = $transactionStatus;

        return $this;
    }

    /**
     * Get the value of active
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * Set the value of active
     *
     * @return  self
     */
    public function setActive($active)
    {
        $this->active = $active;

        return $this;
    }

    /**
     * Get the value of preauth
     */
    public function getPreauth()
    {
        return $this->preauth;
    }

    /**
     * Set the value of preauth
     *
     * @return  self
     */
    public function setPreauth($preauth)
    {
        $this->preauth = $preauth;

        return $this;
    }

    /**
     * Get the value of recurring
     */
    public function getRecurring()
    {
        return $this->recurring;
    }

    /**
     * Set the value of recurring
     *
     * @return  self
     */
    public function setRecurring($recurring)
    {
        $this->recurring = $recurring;

        return $this;
    }

    /**
     * Get the value of saferpayAliasId
     */
    public function getSaferpayAliasId()
    {
        return $this->saferpayAliasId;
    }

    /**
     * Set the value of saferpayAliasId
     *
     * @return  self
     */
    public function setSaferpayAliasId($saferpayAliasId)
    {
        $this->saferpayAliasId = $saferpayAliasId;

        return $this;
    }

    /**
     * Get the value of fraudReviewStatus
     */
    public function getFraudReviewStatus()
    {
        return $this->fraudReviewStatus;
    }

    /**
     * Set the value of fraudReviewStatus
     *
     * @return  self
     */
    public function setFraudReviewStatus($fraudReviewStatus)
    {
        $this->fraudReviewStatus = $fraudReviewStatus;

        return $this;
    }

    /**
     * Get the value of orderTransactionId
     */
    public function getOrderTransactionId()
    {
        return $this->orderTransactionId;
    }

    /**
     * Set the value of orderTransactionId
     *
     * @return  self
     */
    public function setOrderTransactionId($orderTransactionId)
    {
        $this->orderTransactionId = $orderTransactionId;

        return $this;
    }

    /**
     * Get the value of orderId
     */
    public function getOrderId()
    {
        return $this->orderId;
    }

    /**
     * Set the value of orderId
     *
     * @return  self
     */
    public function setOrderId($orderId)
    {
        $this->orderId = $orderId;

        return $this;
    }

    /**
     * Get the value of paymentId
     */
    public function getPaymentId()
    {
        return $this->paymentId;
    }

    /**
     * Set the value of paymentId
     *
     * @return  self
     */
    public function setPaymentId($paymentId)
    {
        $this->paymentId = $paymentId;

        return $this;
    }
}
