<?php

declare(strict_types=1);
/**
 *  Saferpay PaymentService
 *  NOTICE OF LICENSE
 *
 * Once you have purchased the software with PIT Solutions AG
 * or one of its  authorised resellers and provided that you comply with the conditions of this contract,
 * PIT Solutions AG grants you a non-exclusive license,
 * unlimited in time for the usage of the software in the manner of and for the purposes specified in License.txt
 * available in extension package, according to the subsequent regulations
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to
 * newer versions in the future.
 */

namespace Saferpay\Shopware\Core\Content\Saferpay;

use Shopware\Core\Framework\DataAbstractionLayer\Field\Flag\Required;
use Shopware\Core\Framework\DataAbstractionLayer\EntityDefinition;
use Shopware\Core\Framework\DataAbstractionLayer\Field\DateTimeField;
use Shopware\Core\Framework\DataAbstractionLayer\Field\FkField;
use Shopware\Core\Framework\DataAbstractionLayer\Field\Flag\PrimaryKey;
use Shopware\Core\Framework\DataAbstractionLayer\Field\IdField;
use Shopware\Core\Framework\DataAbstractionLayer\Field\ManyToOneAssociationField;
use Shopware\Core\Framework\DataAbstractionLayer\Field\StringField;
use Shopware\Core\Framework\DataAbstractionLayer\FieldCollection;

class SaferpayTransactionHistoryDefinition extends EntityDefinition
{
    public const ENTITY_NAME = 'saferpay_transaction_history';

    public function getEntityName(): string
    {
        return self::ENTITY_NAME;
    }

    public function getCollectionClass(): string
    {
        return SaferpayTransactionHistoryCollection::class;
    }

    public function getEntityClass(): string
    {
        return SaferpayTransactionHistoryEntity::class;
    }

    protected function defineFields(): FieldCollection
    {
        return new FieldCollection([
            (new IdField('id', 'id'))->addFlags(new Required(), new PrimaryKey()),
            (new FkField(
                'payment_transaction_id',
                'paymentTransactionId',
                SaferpayPaymentTransactionDefinition::class
            )),
            (new StringField('transaction_status', 'transactionStatus')),
            (new StringField('custom_errorlog_code', 'customErrorCode')),
            (new StringField('custom_error_msg', 'customErrorMsg')),
            (new StringField('request_id', 'requestId')),
            (new StringField('transaction_id', 'transactionId')),
            (new DateTimeField('transaction_date', 'transactionDate')),

            new ManyToOneAssociationField(
                'saferpayPaymentTransaction',
                'payment_transaction_id',
                SaferpayPaymentTransactionDefinition::class,
                'id',
                false
            ),
        ]);
    }
}
