<?php

declare(strict_types=1);
/**
 *  Saferpay PaymentService
 *  NOTICE OF LICENSE
 *
 * Once you have purchased the software with PIT Solutions AG
 * or one of its  authorised resellers and provided that you comply with the conditions of this contract,
 * PIT Solutions AG grants you a non-exclusive license,
 * unlimited in time for the usage of the software in the manner of and for the purposes specified in License.txt
 * available in extension package, according to the subsequent regulations
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to
 * newer versions in the future.
 */

namespace Saferpay\Shopware\Core\Content\Saferpay;

use DateTimeInterface;
use Shopware\Core\Framework\DataAbstractionLayer\Entity;
use Shopware\Core\Framework\DataAbstractionLayer\EntityIdTrait;

class SaferpayTransactionHistoryEntity extends Entity
{
    use EntityIdTrait;

    protected ?string $paymentTransactionId;
    protected ?string $transactionStatus;
    protected ?string $customErrorCode;
    protected ?string $customErrorMsg;
    protected ?string $requestId;
    protected ?string $transactionId;
    protected ?DateTimeInterface $transactionDate;

    /**
     * Get the value of paymentTransactionId
     */
    public function getPaymentTransactionId()
    {
        return $this->paymentTransactionId;
    }

    /**
     * Set the value of paymentTransactionId
     *
     * @return  self
     */
    public function setPaymentTransactionId($paymentTransactionId)
    {
        $this->paymentTransactionId = $paymentTransactionId;

        return $this;
    }

    /**
     * Get the value of transactionStatus
     */
    public function getTransactionStatus()
    {
        return $this->transactionStatus;
    }

    /**
     * Set the value of transactionStatus
     *
     * @return  self
     */
    public function setTransactionStatus($transactionStatus)
    {
        $this->transactionStatus = $transactionStatus;

        return $this;
    }

    /**
     * Get the value of customErrorCode
     */
    public function getCustomErrorCode()
    {
        return $this->customErrorCode;
    }

    /**
     * Set the value of customErrorCode
     *
     * @return  self
     */
    public function setCustomErrorCode($customErrorCode)
    {
        $this->customErrorCode = $customErrorCode;

        return $this;
    }

    /**
     * Get the value of customErrorMsg
     */
    public function getCustomErrorMsg()
    {
        return $this->customErrorMsg;
    }

    /**
     * Set the value of customErrorMsg
     *
     * @return  self
     */
    public function setCustomErrorMsg($customErrorMsg)
    {
        $this->customErrorMsg = $customErrorMsg;

        return $this;
    }

    /**
     * Get the value of requestId
     */
    public function getRequestId()
    {
        return $this->requestId;
    }

    /**
     * Set the value of requestId
     *
     * @return  self
     */
    public function setRequestId($requestId)
    {
        $this->requestId = $requestId;

        return $this;
    }

    /**
     * Get the value of transactionId
     */
    public function getTransactionId()
    {
        return $this->transactionId;
    }

    /**
     * Set the value of transactionId
     *
     * @return  self
     */
    public function setTransactionId($transactionId)
    {
        $this->transactionId = $transactionId;

        return $this;
    }

    /**
     * Get the value of transactionDate
     */
    public function getTransactionDate()
    {
        return $this->transactionDate;
    }

    /**
     * Set the value of transactionDate
     *
     * @return  self
     */
    public function setTransactionDate($transactionDate)
    {
        $this->transactionDate = $transactionDate;

        return $this;
    }
}
