<?php declare(strict_types=1);

namespace Saferpay\Shopware\Migration;

use Doctrine\DBAL\Connection;
use Shopware\Core\Framework\Migration\MigrationStep;

class Migration1689659056SaferpayPaymentTransaction extends MigrationStep
{
    public function getCreationTimestamp(): int
    {
        return 1689659056;
    }

    public function update(Connection $connection): void
    {
        // implement update
        $sql = <<<SQL
        CREATE TABLE IF NOT EXISTS `saferpay_payment_transaction` (
            `id` BINARY(16) NOT NULL,
            `payment_id` BINARY(16),
            `order_id` BINARY(16),
            `customer_id` BINARY(16),
            `saferpay_request_id` VARCHAR(255) COLLATE utf8mb4_unicode_ci,
            `saferpay_token` VARCHAR(255) COLLATE utf8mb4_unicode_ci,
            `saferpay_token_expiry_date` DATETIME(3),
            `authorisation_method` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `saferpay_customer_id` INT(10),
            `transaction_type` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `authorization_amount` FLOAT(20),
            `transaction_mode` TINYINT(1) COLLATE utf8mb4_unicode_ci,
            `currency_code` VARCHAR(10) COLLATE utf8mb4_unicode_ci,
            `language_code` VARCHAR(10) COLLATE utf8mb4_unicode_ci,
            `captured_amount` FLOAT(20),
            `capture_id` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `saferpay_payment_info` JSON,
            `liability_shift_status` TINYINT(1) COLLATE utf8mb4_unicode_ci,
            `liable_entity` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `three_ds_liability_shift` TINYINT(1) COLLATE utf8mb4_unicode_ci,
            `dcc_status` TINYINT(1) COLLATE utf8mb4_unicode_ci,
            `dcc_info` JSON,
            `alias_register_status` TINYINT(1) COLLATE utf8mb4_unicode_ci,
            `paid_status` TINYINT(1) COLLATE utf8mb4_unicode_ci,
            `transaction_status` TINYINT(1) COLLATE utf8mb4_unicode_ci,
            `active` TINYINT(1) COLLATE utf8mb4_unicode_ci,
            `preauth` TINYINT(1) COLLATE utf8mb4_unicode_ci,
            `recurring` TINYINT(1) COLLATE utf8mb4_unicode_ci,
            `saferpay_alias_id` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `fraud_review_status` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `created_at` DATETIME(3) NOT NULL,
            `updated_at` DATETIME(3),
            PRIMARY KEY (`id`),
            FOREIGN KEY (`payment_id`) REFERENCES `payment_method`(`id`),
            FOREIGN KEY (`order_id`) REFERENCES `order`(`id`),
            FOREIGN KEY (`customer_id`) REFERENCES `customer`(`id`)
        )
            ENGINE = InnoDB
            DEFAULT CHARSET = utf8mb4
            COLLATE = utf8mb4_unicode_ci;
        SQL;
        $connection->executeStatement($sql);
    }

    public function updateDestructive(Connection $connection): void
    {
        // implement update destructive
    }
}
