<?php

declare(strict_types=1);

namespace Saferpay\Shopware\Migration;

use Doctrine\DBAL\Connection;
use Shopware\Core\Framework\Migration\MigrationStep;

class Migration1689671000SaferpayTransactionHistory extends MigrationStep
{
    public function getCreationTimestamp(): int
    {
        return 1689671000;
    }

    public function update(Connection $connection): void
    {
        // implement update
        $sql = <<<SQL
        CREATE TABLE IF NOT EXISTS `saferpay_transaction_history` (
            `id` BINARY(16) NOT NULL,
            `payment_transaction_id` BINARY(16),
            `transaction_status` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `request_id` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `transaction_id` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `transaction_date` DATETIME(3),
            `created_at` DATETIME(3) NOT NULL,
            `updated_at` DATETIME(3),
            PRIMARY KEY (`id`),
            FOREIGN KEY (`payment_transaction_id`) REFERENCES `saferpay_payment_transaction`(`id`)
        )
        ENGINE = InnoDB
        DEFAULT CHARSET = utf8mb4
        COLLATE = utf8mb4_unicode_ci;
        SQL;
        $connection->executeStatement($sql);
    }

    public function updateDestructive(Connection $connection): void
    {
        // implement update destructive
    }
}
