<?php

declare(strict_types=1);

namespace Saferpay\Shopware\Migration;

use Doctrine\DBAL\Connection;
use Shopware\Core\Framework\Migration\MigrationStep;

class Migration1689685221SaferpayPaymentTransactionAlter extends MigrationStep
{
    public function getCreationTimestamp(): int
    {
        return 1689685221;
    }

    public function update(Connection $connection): void
    {
        $schema = $connection->fetchOne('SELECT DATABASE()');
        $sql = "SELECT COUNT(*) as column_count
                FROM information_schema.columns
                WHERE table_schema ='.$schema.' AND table_name = 'saferpay_payment_transaction' AND column_name = 'order_transaction_id';";
        $result = $connection->executeQuery($sql);
        $columnCount = $result->fetchOne();

        if ($columnCount == 0) {
            $sql = <<<SQL
        ALTER TABLE `saferpay_payment_transaction` ADD `order_transaction_id` BINARY(16);
        ALTER TABLE `saferpay_payment_transaction`
         ADD FOREIGN KEY (`order_transaction_id`) REFERENCES `order_transaction`(`id`);
        SQL;
            $connection->executeStatement($sql);
        }
    }

    public function updateDestructive(Connection $connection): void
    {
        // implement update destructive
    }
}
