<?php declare(strict_types=1);

namespace Saferpay\Shopware\Migration;

use Doctrine\DBAL\Connection;
use Shopware\Core\Framework\Migration\MigrationStep;

class Migration1689844546SaferpayTransactionHistoryAlterForeignKey extends MigrationStep
{
    public function getCreationTimestamp(): int
    {
        return 1689844546;
    }

    public function update(Connection $connection): void
    {
        // implement update
        $sql = <<<SQL
        SET FOREIGN_KEY_CHECKS = 0;
-- Drop the first foreign key if it exists
SET @var1 = IF((
    SELECT true
    FROM information_schema.TABLE_CONSTRAINTS
    WHERE
        CONSTRAINT_SCHEMA = DATABASE() AND
        TABLE_NAME        = 'saferpay_transaction_history' AND
        CONSTRAINT_NAME   = 'saferpay_transaction_history_ibfk_1' AND
        CONSTRAINT_TYPE   = 'FOREIGN KEY'
) = true, 'ALTER TABLE saferpay_transaction_history DROP FOREIGN KEY saferpay_transaction_history_ibfk_1', 'SELECT 1');

PREPARE stmt1 FROM @var1;
EXECUTE stmt1;
DEALLOCATE PREPARE stmt1;

-- Insert new foreign key if not exists
SET @var2 = IF((
    SELECT true
    FROM information_schema.TABLE_CONSTRAINTS
    WHERE
        CONSTRAINT_SCHEMA = DATABASE() AND
        TABLE_NAME        = 'saferpay_transaction_history' AND
        CONSTRAINT_NAME   = 'fk.saferpay_transaction_history.payment_transaction_id' AND
        CONSTRAINT_TYPE   = 'FOREIGN KEY'
) = false, 'ALTER TABLE `saferpay_transaction_history` ADD CONSTRAINT
 `fk.saferpay_transaction_history.payment_transaction_id`
 FOREIGN KEY (`payment_transaction_id`) REFERENCES `saferpay_payment_transaction`(`id`)
  ON DELETE CASCADE ON UPDATE CASCADE', 'SELECT 1');

PREPARE stmt2 FROM @var2;
EXECUTE stmt2;
DEALLOCATE PREPARE stmt2;
SQL;

$connection->executeStatement($sql);

    }

    public function updateDestructive(Connection $connection): void
    {
        // implement update destructive
    }
}
