<?php

declare(strict_types=1);

namespace Saferpay\Shopware\Migration;

use Doctrine\DBAL\Connection;
use Shopware\Core\Framework\Migration\MigrationStep;

class Migration1691569958SaferpayTransactionHistoryUpdate extends MigrationStep
{
    public function getCreationTimestamp(): int
    {
        return 1691569958;
    }

    public function update(Connection $connection): void
    {
        $schema = $connection->fetchOne('SELECT DATABASE()');
        $sql = "SELECT COUNT(*) as column_count
        FROM information_schema.columns
        WHERE table_schema ='.$schema.' AND table_name = 'saferpay_transaction_history' AND column_name = 'custom_errorlog_code';";
        
        
        $result = $connection->executeQuery($sql);
        $columnCount = $result->fetchOne();
        
        if ($columnCount == 0) {
            $sql = <<<SQL
        ALTER TABLE `saferpay_transaction_history`
            ADD `custom_errorlog_code` varchar(100) COLLATE 'utf8mb4_unicode_ci' NULL AFTER `transaction_status`,
            ADD `custom_error_msg` varchar(255) COLLATE 'utf8mb4_unicode_ci' NULL AFTER `custom_errorlog_code`;
        SQL;
        
            $connection->executeStatement($sql);
        }
        
    }

    public function updateDestructive(Connection $connection): void
    {
        // implement update destructive
    }
}
