<?php declare(strict_types=1);

namespace Saferpay\Shopware\Migration;

use Doctrine\DBAL\Connection;
use Shopware\Core\Framework\Migration\MigrationStep;

class Migration1706684955SaferpayCustomerSecureTransaction extends MigrationStep
{
    public function getCreationTimestamp(): int
    {
        return 1706684955;
    }

    public function update(Connection $connection): void
    {
        // implement update
        $sql = <<<SQL
        CREATE TABLE IF NOT EXISTS `saferpay_customer_secure_transaction` (
            `id` BINARY(16) NOT NULL,
            `customer_id` BINARY(16),
            `saferpay_request_id` VARCHAR(255) COLLATE utf8mb4_unicode_ci,
            `saferpay_token` VARCHAR(255) COLLATE utf8mb4_unicode_ci,
            `saferpay_alias_id` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `saferpay_alias_lifetime` INT(10) COLLATE utf8mb4_unicode_ci,
            `saferpay_payment_method` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `saferpay_display_text` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `saferpay_masked_number` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `saferpay_exp_year` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `saferpay_exp_month` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `saferpay_holder_name` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `saferpay_customer_id` INT(10),
            `saferpay_authenticated` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `live_transaction` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `alias_active` VARCHAR(100) COLLATE utf8mb4_unicode_ci,
            `saferpay_created_at` DATETIME(3),
            `created_at` DATETIME(3) NOT NULL,
            `updated_at` DATETIME(3),
            PRIMARY KEY (`id`),
            CONSTRAINT `fk.saferpay_customer_secure_transaction.customer_id`
            FOREIGN KEY (`customer_id`)
            REFERENCES `customer`(`id`)
            ON DELETE CASCADE
            ON UPDATE CASCADE
        )
            ENGINE = InnoDB
            DEFAULT CHARSET = utf8mb4
            COLLATE = utf8mb4_unicode_ci;
        SQL;
        $connection->executeStatement($sql);
    }

    public function updateDestructive(Connection $connection): void
    {
        // implement update destructive
    }
}
