<?php

declare(strict_types=1);

namespace Saferpay\Shopware\Migration;

use Doctrine\DBAL\Connection;
use Shopware\Core\Framework\Migration\MigrationStep;

class Migration1721820544SaferpayPaymentTransactionForeignKeyRemove extends MigrationStep
{
    public function getCreationTimestamp(): int
    {
        return 1721820544;
    }

    public function update(Connection $connection): void
    {
        $connection->executeStatement("ALTER TABLE saferpay_payment_transaction DROP FOREIGN KEY `fk.saferpay_payment_transaction.customer_id`;");
        $connection->executeStatement("ALTER TABLE saferpay_payment_transaction DROP FOREIGN KEY `fk.saferpay_payment_transaction.order_id`;");
        $connection->executeStatement("ALTER TABLE saferpay_payment_transaction DROP FOREIGN KEY `fk.saferpay_payment_transaction.order_transaction_id`;");

        $connection->executeStatement('ALTER TABLE saferpay_payment_transaction DROP INDEX `fk.saferpay_payment_transaction.customer_id`;');
        $connection->executeStatement('ALTER TABLE saferpay_payment_transaction DROP INDEX `fk.saferpay_payment_transaction.order_id`;');
        $connection->executeStatement('ALTER TABLE saferpay_payment_transaction DROP INDEX `fk.saferpay_payment_transaction.order_transaction_id`;');
    }

    public function updateDestructive(Connection $connection): void
    {
        // implement update destructive
    }
}
