import Plugin from 'src/plugin-system/plugin.class';
var isFieldsValid = {
    holdername: false,
    cardnumber: false,
    expiration: false,
    cvc: true
}
var token = -1;
export default class SaferpayFieldsCustom extends Plugin {

    init() {
        this.creditCardDiv = this.el.querySelector('saferpay-div');
        var styleDesign;
        switch (creditParams.cardTemplate) {
            case 'sample_1': styleDesign = {
                '.form-control': 'border: solid 1px #CFCFCF; border-radius: 0px; height: 40px !important; width: calc(100% - 1px);',

                '.form-control.is-valid, .was-validated .form-control:valid': 'border-color: #28a745;padding-right: calc(1.5em + .75rem); background-image: url(data:image/svg+xml;base64,PHN2ZyB4bWxucz0naHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmcnIHZpZXdCb3g9JzAgMCA4IDgnPjxwYXRoIGZpbGw9JyMyOGE3NDUnIGQ9J00yLjMgNi43M0wuNiA0LjUzYy0uNC0xLjA0LjQ2LTEuNCAxLjEtLjhsMS4xIDEuNCAzLjQtMy44Yy42LS42MyAxLjYtLjI3IDEuMi43bC00IDQuNmMtLjQzLjUtLjguNC0xLjEuMXonLz48L3N2Zz4=);background-repeat: no-repeat; background-position: 83% 50%; background-size: calc(.75em + .375rem) calc(.75em + .375rem);',

                '.form-control.is-invalid, .was-validated .form-control:invalid': '  border-color: #dc3545;    padding-right: calc(1.5em + .75rem);background-image: url(data:image/svg+xml;base64,PHN2ZyB4bWxucz0naHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmcnIGZpbGw9JyNkYzM1NDUnIHZpZXdCb3g9Jy0yIC0yIDcgNyc+PHBhdGggc3Ryb2tlPScjZGMzNTQ1JyBkPSdNMCAwbDMgM20wLTNMMCAzJy8+PGNpcmNsZSByPScuNScvPjxjaXJjbGUgY3g9JzMnIHI9Jy41Jy8+PGNpcmNsZSBjeT0nMycgcj0nLjUnLz48Y2lyY2xlIGN4PSczJyBjeT0nMycgcj0nLjUnLz48L3N2Zz4=);background-repeat: no-repeat;background-position: 83% 50%;    background-size: calc(.75em + .375rem) calc(.75em + .375rem);',

                '.form-control.is-valid.is-pristine': 'background-image: inherit; border-color:#CFCFCF;',

                '.input-group .logo': 'right: 2em;',

                '.expiration__input': 'padding: 0.3125rem 0.3125rem 0.125rem 0.8125rem;',

                '.cardnumber__logos': 'right: 15px;',

                '#fields-holder-name': 'width:99%; display:block;',

                '#fields-card-number': 'width:99%; display:block;'
            }; break;
            case 'sample_2': styleDesign = {
                '.form-control': ' border: solid 1px #CFCFCF; border-radius: 8px; height: 46px !important',

                '.form-control.is-valid, .was-validated .form-control:valid': 'border-color: #28a745;padding-right: calc(1.5em + .75rem); background-image: url(data:image/svg+xml;base64,PHN2ZyB4bWxucz0naHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmcnIHZpZXdCb3g9JzAgMCA4IDgnPjxwYXRoIGZpbGw9JyMyOGE3NDUnIGQ9J00yLjMgNi43M0wuNiA0LjUzYy0uNC0xLjA0LjQ2LTEuNCAxLjEtLjhsMS4xIDEuNCAzLjQtMy44Yy42LS42MyAxLjYtLjI3IDEuMi43bC00IDQuNmMtLjQzLjUtLjguNC0xLjEuMXonLz48L3N2Zz4=);background-repeat: no-repeat; background-position: calc(100% - 34px) 50%; background-size: calc(.75em + .375rem) calc(.75em + .375rem);',

                '.form-control.is-invalid, .was-validated .form-control:invalid': '  border-color: #dc3545;    padding-right: calc(1.5em + .75rem);background-image: url(data:image/svg+xml;base64,PHN2ZyB4bWxucz0naHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmcnIGZpbGw9JyNkYzM1NDUnIHZpZXdCb3g9Jy0yIC0yIDcgNyc+PHBhdGggc3Ryb2tlPScjZGMzNTQ1JyBkPSdNMCAwbDMgM20wLTNMMCAzJy8+PGNpcmNsZSByPScuNScvPjxjaXJjbGUgY3g9JzMnIHI9Jy41Jy8+PGNpcmNsZSBjeT0nMycgcj0nLjUnLz48Y2lyY2xlIGN4PSczJyBjeT0nMycgcj0nLjUnLz48L3N2Zz4=);background-repeat: no-repeat;background-position: 83% 50%;    background-size: calc(.75em + .375rem) calc(.75em + .375rem);',

                '#fields-card-number.is-invalid ~ span.logo': 'right: 28px',

                '#fields-card-number.is-valid ~ span.logo': 'right: 28px',

                '.form-control.is-valid.is-pristine': 'background-image: inherit; border-color:#CFCFCF;'
            }; break;
            case 'sample_3': styleDesign = {
                '.form-control': 'background-color: transparent;color: #fff;border-radius: 0px;border:none;outline: none;',

                '.form-control::-webkit-input-placeholder': 'color:#becff2',

                '.form-control::-moz-placeholder': 'color:#becff2',

                '.form-control:-ms-input-placeholder': 'color:#becff2',

                '.form-control.input-verificationcode': 'text-align: left; background-position: 100% 50% !important; padding-right: calc(.75em + .375rem) !important;',

                '.form-control.is-valid, .was-validated .form-control:valid': 'border-color: #28a745;padding-right: calc(1.5em + .375rem); background-image: url(data:image/svg+xml;base64,PHN2ZyB4bWxucz0naHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmcnIHZpZXdCb3g9JzAgMCA4IDgnPjxwYXRoIGZpbGw9JyMyOGE3NDUnIGQ9J00yLjMgNi43M0wuNiA0LjUzYy0uNC0xLjA0LjQ2LTEuNCAxLjEtLjhsMS4xIDEuNCAzLjQtMy44Yy42LS42MyAxLjYtLjI3IDEuMi43bC00IDQuNmMtLjQzLjUtLjguNC0xLjEuMXonLz48L3N2Zz4=);background-repeat: no-repeat; background-position: calc(100% - 5px) 50%; background-size: calc(.75em + .375rem) calc(.75em + .375rem);',

                '.form-control.is-invalid, .was-validated .form-control:invalid': '  border-color: #dc3545;    padding-right: calc(1.5em + .2rem);background-image: url(data:image/svg+xml;base64,PHN2ZyB4bWxucz0naHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmcnIGZpbGw9JyNkYzM1NDUnIHZpZXdCb3g9Jy0yIC0yIDcgNyc+PHBhdGggc3Ryb2tlPScjZGMzNTQ1JyBkPSdNMCAwbDMgM20wLTNMMCAzJy8+PGNpcmNsZSByPScuNScvPjxjaXJjbGUgY3g9JzMnIHI9Jy41Jy8+PGNpcmNsZSBjeT0nMycgcj0nLjUnLz48Y2lyY2xlIGN4PSczJyBjeT0nMycgcj0nLjUnLz48L3N2Zz4=);background-repeat: no-repeat;background-position: calc(100% - 4px) 50%;    background-size: calc(.75em + .375rem) calc(.75em + .375rem);',

                '.form-control.is-valid.is-pristine': 'background-image: inherit; border-color:#CFCFCF;',

                '#fields-expiration': 'min-width: auto;',

                'input.input-cardnumber': 'width: 100%;',

                'input.input-expiry': 'width: 100%; padding-right: calc(.75em + .375rem) !important;background-position: 100% 50% !important;',
                '.cardnumber__logos': 'right: 0px;',
            }; break;
            case 'sample_4': styleDesign = {
                '.form-control.is-valid, .was-validated .form-control:valid': 'border-color: #28a745;padding-right: calc(1.5em + .75rem); background-image: url(data:image/svg+xml;base64,PHN2ZyB4bWxucz0naHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmcnIHZpZXdCb3g9JzAgMCA4IDgnPjxwYXRoIGZpbGw9JyMyOGE3NDUnIGQ9J00yLjMgNi43M0wuNiA0LjUzYy0uNC0xLjA0LjQ2LTEuNCAxLjEtLjhsMS4xIDEuNCAzLjQtMy44Yy42LS42MyAxLjYtLjI3IDEuMi43bC00IDQuNmMtLjQzLjUtLjguNC0xLjEuMXonLz48L3N2Zz4=);background-repeat: no-repeat; background-position:calc(100% - 34px) 50%; background-size: calc(.75em + .375rem) calc(.75em + .375rem);',

                '#fields-card-number': 'padding-left: 0',

                '#fields-card-number ~ span.logo': 'position: absolute; left: 10px;',

                '.form-control.is-invalid, .was-validated .form-control:invalid': '  border-color: #dc3545;    padding-right: calc(1.5em + .75rem);background-image: url(data:image/svg+xml;base64,PHN2ZyB4bWxucz0naHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmcnIGZpbGw9JyNkYzM1NDUnIHZpZXdCb3g9Jy0yIC0yIDcgNyc+PHBhdGggc3Ryb2tlPScjZGMzNTQ1JyBkPSdNMCAwbDMgM20wLTNMMCAzJy8+PGNpcmNsZSByPScuNScvPjxjaXJjbGUgY3g9JzMnIHI9Jy41Jy8+PGNpcmNsZSBjeT0nMycgcj0nLjUnLz48Y2lyY2xlIGN4PSczJyBjeT0nMycgcj0nLjUnLz48L3N2Zz4=);background-repeat: no-repeat;background-position: 83% 50%;    background-size: calc(.75em + .375rem) calc(.75em + .375rem);',

                '.form-control.is-valid.is-pristine': 'background-image: inherit; border-color:#CFCFCF;',

                'input#fields-card-number': 'padding-left: .75rem;',
                
                '.input-expiry': 'min-height: 36px;',
                
                '.input-large': 'width:99%;',
                '.form-control.input-verificationcode': 'background-position: calc(100% - 4px) 50% !important;padding-right: calc(1em + .375rem) !important;',
                'input.input-expiry': 'padding-right: calc(1em + .375rem) !important;background-position: calc(100% - 4px) 50% !important;',
                '.cardnumber__logos': 'right: 3px;',
            }; break;
            default: styleDesign = {}; break;
        }

        var labels = {
            invalid: creditParams.labels.invalid,
            empty: creditParams.labels.empty,
            unsupported: creditParams.labels.unsupported,
            expired: creditParams.labels.expired
        };
        SaferpayFields.init({
            accessToken: creditParams.accessToken,
            url: creditParams.sourceUrl,
            placeholders: {
                holdername: creditParams.cardHolderName,
                cardnumber: '0000 0000 0000 0000',
                expiration: creditParams.expiration,
                cvc: '000'
            },
            paymentMethods: creditParams.paymentMethods,
            style: styleDesign,
            cssUrl: creditParams.cssUrl,
            onSuccess:  (evt) => {
                this.addToken('successCallback');
            },
            onError: (evt) => {
                //  console.log('On init error');
                this.addToken('errorCallback');
            },
            onBlur: (evt) => {
                //Callback on blur (Card Holder leaves field)
            },
            onValidated: (evt) => {
                var elemIds = {
                    cardnumber: 'card-number-help',
                    expiration: 'expiration-help',
                    holdername: 'holder-name-help',
                    cvc: 'cvc-help'
                }                
                if (elemIds[evt.fieldType]) {
                    isFieldsValid[evt.fieldType] = evt.isValid;
                    var elem = document.getElementById(elemIds[evt.fieldType]);
                    if (evt.isValid) {
                        elem.innerHTML = '';
                        document.querySelector("#" + evt.id).setAttribute('data-isvalid', 'true');
                        this.addToken('validateCallback');
                    } else {
                        var key = evt.reason || 'invalid';
                        elem.innerHTML = labels[key];
                        this.addToken('validateCallback');
                    }
                }
            },

            onFocus: function (e) {
                var pictureCard = document.querySelector("#picture .saferpaycard");
                if (pictureCard) {
                    if (e.fieldType === 'cvc') {
                        pictureCard.classList.add('show-back');
                        pictureCard.classList.remove('cardnumber');
                        pictureCard.classList.remove('expiration');
                        pictureCard.classList.add('cvc');
                    } else if (e.fieldType === 'cardnumber') {
                        pictureCard.classList.remove('show-back');
                        pictureCard.classList.add('cardnumber');
                        pictureCard.classList.remove('expiration');
                        pictureCard.classList.remove('cvc');
                    } else if (e.fieldType === 'expiration') {
                        pictureCard.classList.remove('show-back');
                        pictureCard.classList.remove('cardnumber');
                        pictureCard.classList.add('expiration');
                        pictureCard.classList.remove('cvc');
                    }
                }
            }
        });
        document.querySelector('#saferpay-div').style = 'opacity:1';
        document.getElementById('tos').addEventListener('change', (ele) => {
            this.addToken('TOSCHANGE');
        });
    }

    addToken(data) {        
        var creditForm = document.querySelector('div.payment-methods');
        var savedCardListElem = document.getElementById('customer_selected_alias');
        if (data != 'errorCallback') {
            var isFieldsValidTemp = Object.values(isFieldsValid).some(value => value === false);
            if (!isFieldsValidTemp) {
                token = 1;
                if (document.getElementById('tos') == null) {
                    document.querySelector("#saferpayIframeBtn").setAttribute("data-bs-toggle", "modal");
                }
                else if (document.getElementById('tos').checked) {
                    document.querySelector("#saferpayIframeBtn").setAttribute("data-bs-toggle", "modal");
                }
            }
            else {
                token = -1;
                if(savedCardListElem) {
                    if (savedCardListElem.value == ''){
                        document.querySelector("#saferpayIframeBtn").removeAttribute("data-bs-toggle", "modal");
                    }
                } else {
                    document.querySelector("#saferpayIframeBtn").removeAttribute("data-bs-toggle", "modal");
                }
            }
        }
        if (!document.querySelector('#token')) {
            var tokenInput = document.createElement('input');
            tokenInput.setAttribute('class', 'form-control');
            tokenInput.setAttribute('id', 'token');
            tokenInput.setAttribute('name', 'token');
            tokenInput.setAttribute('value', token);
            tokenInput.setAttribute('type', 'hidden');
            creditForm.appendChild(tokenInput);
        } else if (document.querySelector('#token') && (document.querySelector('#token').value == '1' || document.querySelector('#token').value == '-1')) {
            document.querySelector('#token').setAttribute('value', token);
            if (document.querySelector('#token').value == '1')
                document.querySelector(".credit-card-error-div").style = "display:none;";
        }
        return true;
    }    
}