import Plugin from 'src/plugin-system/plugin.class';
import HttpClient from 'src/service/http-client.service';

export default class SaveCardSaferpayScriptsPlugin extends Plugin {

    data() {
        return {
            cardId: null,
        }
    }

    init() {
        this._client = new HttpClient();
        this.deleteModal = this.el.querySelector('#deleteModal');
        const actionButtons = document.querySelectorAll('.saved-card-action-btn');
        actionButtons.forEach(button => {
            button.addEventListener('click', function () {
                if (button.classList.contains('delete-saved-card')) {
                    this.cardId = button.getAttribute('data-target-id');
                    button.setAttribute('data-bs-toggle', 'modal');
                    button.setAttribute('data-bs-target', '#deleteModal');
                    document.querySelector('#currentCardId').value = this.cardId;
                    button.click();
                } else if (button.classList.contains('edit-saved-card')) {
                    button.parentNode.querySelector('.edit-div').classList.remove('hidden');
                    button.classList.add('hidden');
                } else if (button.classList.contains('cancel-save-card')) {
                    button.parentElement.parentElement.classList.add('hidden');
                    button.parentElement.parentElement.parentElement.querySelector('.edit-saved-card').classList.remove('hidden');
                }
            });
        });
        this.deleteSubmit = document.querySelector('#card-delete-submit');
        this.deleteSubmit.onclick = this.fetchDelete.bind(this);
        const selectType = document.querySelector('#cardTypeSelect');
        selectType.addEventListener('change', function (e) {
            let formData = { 'cardType': e.target.value };
            new HttpClient().post('/saferpay/account/saved/card/change/card/type', JSON.stringify(formData), function(){
                window.location.href = window.location.href;
            }, 'application/json', true);
        });
    }

    fetchDelete() {
        this.cardId = document.querySelector('#currentCardId').value;
        this._client.get(
            '/saferpay/account/saved/cards/delete/' + this.cardId,
            (response) => {
                let resp = JSON.parse(response);
                if (resp.status === 'success') {
                    // Add a query parameter to the URL
                    let currentUrl = new URL(window.location.href);
                    currentUrl.searchParams.set('cardDeleted', true);
                    window.location.href = currentUrl.toString();
                }
            }
        );
    }

}