<?php

declare(strict_types=1);
/**
 *  Saferpay PaymentService
 *  NOTICE OF LICENSE
 *
 * Once you have purchased the software with PIT Solutions AG
 * or one of its  authorised resellers and provided that you comply with the conditions of this contract,
 * PIT Solutions AG grants you a non-exclusive license,
 * unlimited in time for the usage of the software in the manner of and for the purposes specified in License.txt
 * available in extension package, according to the subsequent regulations
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade this extension to
 * newer versions in the future.
 */

namespace Saferpay\Shopware\Service;

use DateTime;
use Shopware\Core\Framework\Context;
use Shopware\Core\Framework\DataAbstractionLayer\EntityRepository;

class LogEntryService
{

    private EntityRepository $logEntryRepository;

    public function __construct(EntityRepository $logEntryRepository)
    {
        $this->logEntryRepository = $logEntryRepository;
    }

    /**
     * Save the exception log in database
     */
    public function addLogEntry(Context $context, $errorMessage, $errorContext)
    {
        $this->logEntryRepository->create(
            [
                [
                    'message' => $errorMessage,
                    'level' => 400,
                    'channel' => 'Saferpay_Shopware',
                    'context' => $errorContext,
                    'extra' => [],
                    'createdAt' => new DateTime('now')
                ]
            ],
            $context
        );
    }
}
